%%
clear all
close all
clc
%Integrationsalgorithmus
%1.2.2
Ta = 0.5;
range = 0:Ta:20;

m = 1;
c = 1;
k = 2;
s0 = 0;
v0 = 0;
x0 = [s0;v0];

A = [0,1; -k/m,-c/m];
B = [0 1/m];

l1 = -c/(2*m) + sqrt((c/2*m)^2-k/m)
l2 = -c/(2*m) - sqrt((c/2*m)^2-k/m)

t = range;

sympref('HeavisideAtOrigin', 1)

%Exakte Loesung aus 1.2.1
y = ((l1+c/m)/(l1-l2)*exp(l1*t) +  (l2+c/m)/(l2-l1)*exp(l2*t))*s0 + ...
         (1/(l1-l2)*exp(l1*t) + 1/(l2-l1)*exp(l2*t))*v0 + ...
         (((1/l1)/(m*(l1-l2)))*(-heaviside(t)+exp(l1*t)))+ ...
         (((1/l2)/(m*(l2-l1)))*(-heaviside(t)+exp(l2*t)));


%Control Systems Toolbox
A = [0 1; -k/m -c/m];
B = [0;1/m];
C = [1,0];
D = 0;

sys = ss(A,B,C,D)
     
%Integrationsalgorithmus
algo = zeros(2,length(range));
algo(:,1)=x0; % Startwert
for n=2:1:length(range)
    %x(n)=x(n-1)+Ta*x'(n-1)
    algo(:,n) = algo(:,n-1)+Ta*(A*algo(:,n-1)+B*heaviside(range(n-1))); 
end

     
figure
plot(t,y); %Exakte Lsung
hold on
plot(t,algo(1,:),'r'); %Integrationsalgorithmus
step(tf(sys),t,'c'); %CST
legend('Exakt','Integrationsalgorithmus','CST')

%%
%1.2.3
sysd = c2d(sys,Ta);
figure
step(tf(sys),t,'r'); %CST kontinuierlich
hold on
step(tf(sysd),t,'b'); %CST Diskret
legend('kontinuierlich','diskret')
