clear all;
close all;
clc;

Ta = 1e-6; %1us
T1 = 1e-3; %1ms
c  = 0.5;
a = 0.4;

A_proc = [exp(-Ta/T1)];
B_proc = [c*(1-exp(-Ta/T1))];
C_proc = [1];
D_proc = [0];

T_jump_start = 10e-3;
T_jump_end = T_jump_start+5e-3;
jump_val = 1000;

u_k = 1;
d_out = 0;
d_in_static = u_k+d_out;

%%
% Gesamtsystem:
A = [exp(-Ta/T1), a*(c*(1-exp(-Ta/T1))); Ta, 1-a*Ta];
B = [0; Ta];
C = [0, 1];
D = 0;
sys = ss(A,B,C,D,Ta);

%%
% 1.6.4 Ruhelage fr u_k = 1 berechnen
% s_k+1 = s_k einsetzen und umformen
s_k_r = (eye(2) - A)\B;

fprintf("Ruhelage bei konstantem u_k: %i\n",s_k_r(2));

%%
% 1.6.5 Maximal bentigter Speicher
sim_time = 0.15;
sim_n = sim_time/Ta+1;
u = ones(sim_n,1);
u(T_jump_start/Ta:T_jump_end/Ta) = 1000;
s = zeros(2,sim_n);
s(:,1) = [0;s_k_r(2)]; % Startwert, = Ruhelage
for k=1:(sim_n-1)
    s(:,k+1)=A*s(:,k) + B*u(k);
end
[m_val,m_ind] = max(s(2,:));
m_time = (m_ind-1) * Ta;
fprintf('Maximaler Speicherverbrauch innerhalb von %is bei %is: %i\n',sim_time,m_time,m_val);
figure
subplot(2,1,1)        % Subplot erzeugen
plot(0:Ta:sim_time,u');
grid on
subplot(2,1,2)        % Zugriff auf zweites Fenster
plot(0:Ta:sim_time,s(2,:));
grid on