close all
clear all
clc
%%
syms i_GSM phi_GSMP w_GSM w_P L_GSM R_GSM k_GSM J_GSM d_cGSM d_vGSM d_GSMP c_GSMP J_P d_cP d_vP d_qP M_ext u_GSM

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Systemgleichungen x_M'=f(x_M,u_M,d_M) == dx
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

x_M=[i_GSM; phi_GSMP; w_GSM; w_P];

di_GSM=1/L_GSM*(u_GSM-R_GSM*i_GSM-k_GSM*w_GSM);
w_GSMP=w_GSM-w_P;
dw_GSM=1/J_GSM*(k_GSM*i_GSM-d_cGSM-d_vGSM*w_GSM+(w_P-w_GSM)*d_GSMP-phi_GSMP*c_GSMP);
dw_P=1/J_P*((w_GSM-w_P)*d_GSMP+phi_GSMP*c_GSMP-d_cP-d_vP*w_P-d_qP*w_P^2-M_ext);

dx = [di_GSM;w_GSMP;dw_GSM;dw_P];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Ruhelagen des Systems berechnen
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[i_GSMr, phi_GSMPr, w_GSMr, w_Pr] = solve(dx == [0;0;0;0],i_GSM, phi_GSMP, w_GSM, w_P);

disp("Ruhelagen des Systems:");
disp("i_GSMr:");
pretty(i_GSMr);
disp("phi_GSMPr:");
pretty(phi_GSMPr);
disp("w_GSMr:");
pretty(w_GSMr);
disp("w_Pr:");
pretty(w_Pr);
%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Linearisierung
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

A = jacobian(dx, x_M)
%A = subs(A,i_GSM,i_GSMr(1));
%A = subs(A,phi_GSMP,phi_GSMPr(1));
%A = subs(A,w_GSM,w_GSMr(1));
A = subs(A,w_P,w_Pr(2)) %w_Pr > 0!

u = u_GSM;
d = M_ext;

B_u = jacobian(dx, u)
B_d = jacobian(dx, d)


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Eigenwerte bestimmen
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
L_GSM=1.4e-3;
R_GSM=0.46;
k_GSM=0.1;
J_GSM=12.4e-3;
d_cGSM=0.152;
d_vGSM=1.8e-3;
J_P=32.5e-3;
d_cP=0.169;
d_vP=2.7e-3;
d_qP=1e-4;
c_GSMP=0.6822;
d_GSMP=1e-5;

u_GSM=5.6;
M_ext=0;
lambda = eig(subs(A));
disp("l1:");
double(lambda(1))
disp("l2:");
double(lambda(2))
disp("l3:");
double(lambda(3))
disp("l4:");
double(lambda(4))




