%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Aufgabe 2.8
% PI Reglerentwurf
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if exist('points','var') == 0
    close all
    clear all
    clc
end

s = tf('s');
sympref('HeavisideAtOrigin', 1);

% Strecke:
V = 1.5;
xi = 0.9;
T = 0.5;
%G(s) = V/(1+2*xi*(s*T)+(s*T)^2)
Gs = tf(V,[T^2, 2*xi*T, 1]);

%A) Spezifikationen:
% Anforderungen an den offenen und geschlossenen Kreis
tr=1.2;   %Anstiegszeit
ue=10;      %Maximales berschwingen
e_inf = 0; %Bleibende Regelabweichung Sprung

%B) Kenngren:
wc = 1.5/tr; %5.2 Durchtrittsfrequenz
phi = 70-ue; %5.3 prozentuelles berschwingen
roh = 1; %5.9 Anzahl Polstellen bei s=0 um e_inf zu erfllen

Iwc = 1i*wc;

%% PI Regler in s

% PI Regler allgemein:
%    R(s) = V_I*(1+sT_I)/s
% 1) Alle bekannten Terme des offenen Kreises == Nur Strecke und Nullstelle bei s=0!
L1 = Gs* 1/s; 
bode(L1);
grid on;
%%
% 2) Bentigte Phasennderung von L1
phase = rad2deg(angle(evalfr(L1,(Iwc)))); % ==> -180-phi
phasen_aenderung = -180+phi-phase;
% --> Phasennderung der brigen Terme (<==> nicht in L1) im PI Regler 
% mssen gleich phasen_aenderung bei wc sein.
% angle(1+ i*wc*TI) == phasen_aenderung
TI = tand(phasen_aenderung)/wc;

L2 = L1 * (1+s*TI);
bode(L1, L2);
grid on;
legend;
%Check phase von L2(i*wc) == -180+phi
% Abweichung durch Ungenauigkeit mglich!
%disp("Phasenabweichung korrigiert?");
%abs(rad2deg(angle(evalfr(L2,(Iwc)))) - (-180+phi)) < 1e-10

%% 3) Verstrkung VI bestimmen
% Amplitude bei wc == 0dB
VI = 1/abs(evalfr(L2,(Iwc)));

% PI Regler:
%    R(s) = VI*(1+s*TI)/s
disp("Entworfener PI Regler:");
R_PI_s = VI*(1+s*TI)/s

L_PI_s = Gs * R_PI_s; %== L2 * VI
bode(L1,L2,L_PI_s);
grid on;
legend;
%disp("Verstrkung korrigiert?");
%abs(abs(evalfr(L_PI,(Iwc))) - 1) < 1e-10


%% Wahl Ta
tr_G = T*exp(acos(xi)/tan(acos(xi))) %6.61

% min(tr)/Ta = 4 bis 10 %6.62
if exist('points','var') == 0
    points = 4;
end
Ta = tr_G/points; %Ta = tr_G/4

Gz = c2d(Gs,Ta,'zoh');
Gq = d2c(Gz,'tustin');

%% PI Regler in q:

q = s;
wc = 1.2/tr; %6.118 Durchtrittsfrequenz
Iwc = 1i*wc;

% PI Regler allgemein:
%    R(q) = V_I*(1+qT_I)/q
% 1) Alle bekannten Terme des offenen Kreises == Nur Strecke und Nullstelle bei q=0!
L1 = Gq* 1/q; 
bode(L1);
grid on;
%%
% 2) Bentigte Phasennderung von L1
phase = rad2deg(angle(evalfr(L1,(Iwc)))); % ==> -180-phi
phasen_aenderung = -180+phi-phase;
% --> Phasennderung der brigen Terme (<==> nicht in L1) im PI Regler 
% mssen gleich phasen_aenderung bei wc sein.
% angle(1+ i*wc*TI) == phasen_aenderung
TI = tand(phasen_aenderung)/wc;

L2 = L1 * (1+q*TI);
bode(L1, L2);
grid on;
legend;
%Check phase von L2(i*wc) == -180+phi
% Abweichung durch Ungenauigkeit mglich!
%disp("Phasenabweichung korrigiert?");
%abs(rad2deg(angle(evalfr(L2,(Iwc)))) - (-180+phi)) < 1e-10

%% 3) Verstrkung VI bestimmen
% Amplitude bei wc == 0dB
VI = 1/abs(evalfr(L2,(Iwc)));

% PI Regler:
%    R(q) = VI*(1+q*TI)/q
disp("Entworfener PI Regler:");
R_PI_q = VI*(1+q*TI)/q

L_PI_q = Gq * R_PI_q; %== L2 * VI
bode(L1,L2,L_PI_q);
grid on;
legend;
%disp("Verstrkung korrigiert?");
%abs(abs(evalfr(L_PI,(Iwc))) - 1) < 1e-10


%% Sprungantworten der Regler

R_PI_qz = c2d(R_PI_q,Ta,'Tustin');
R_PI_sz = c2d(R_PI_s,Ta,'zoh');

L_qz = Gz*R_PI_qz;
L_sz = Gz*R_PI_sz;

Try_q = feedback(L_qz,1);%L_qz/(1+L_qz)    % Fhrungsbertragungsfunktion (geschlossener Kreis) q
Try_s = feedback(L_sz,1);%L_sz/(1+L_sz)    % Fhrungsbertragungsfunktion (geschlossener Kreis) s

step(Try_q,Try_s);
legend;

%%
disp("Stepinfo s");
stepinfo(Try_s)
disp("Stepinfo q");
stepinfo(Try_q)
