close all
clear all
clc

s = tf('s');
VG = 7;
Gs = VG*(1+s/5)/(s*(1+2*0.8*s/4.2+(s/4.2)^2));

% Spezifikationen
e_inf = 0.05;
tr = 0.15;
ue = 15;

wc = 1.5/tr;
phi = 70-ue;
Iwc = 1i*wc;

% Rs = V*R_LEAD*R_LAG
% R_LEAD = (1+s*T_LEAD)/(1+s*eta_LEAD*T_LEAD)
% R_LAG = (1+s*T_LAG)/(1+s*eta_LAG*T_LAG)

%% V Gesamtregler
VL = 1/e_inf; % 5.10
V = VL/VG; % 5.21

%% Phase Lead
L1 = Gs * V;
phase = rad2deg(angle(evalfr(L1,(Iwc))));
phasen_aenderung = -180+phi-phase+10; % 10 Grad mehr wegen Lead/Lag

% arg(R_LEAD) == phasen_aenderung
eta_LEAD = (tand(rad2deg(pi/4) - phasen_aenderung/2))^2 % 0<eta<1
T_LEAD = 1/(sqrt(eta_LEAD)*wc);

R_LEAD = (1+s*T_LEAD)/(1+s*eta_LEAD*T_LEAD)

%% Lag Glied
L2 = Gs * V * R_LEAD;
phase = rad2deg(angle(evalfr(L2,(Iwc))));
phasen_aenderung = -180+phi-phase; % == -10 Grad wegen Lead/Lag
betrag = abs(evalfr(L2,(Iwc)));
betrag_aenderung = 1/betrag;

T_LAG = (betrag_aenderung*sqrt(1+tan(phasen_aenderung)^2)-1)/(wc*tan(phasen_aenderung));
eta_LAG = (wc*T_LAG-tan(phasen_aenderung))/(wc*T_LAG*(1+wc*T_LAG*tan(phasen_aenderung))); % > 1

R_LAG = (1+s*T_LAG)/(1+s*eta_LAG*T_LAG)
%%

Rs = V*R_LEAD*R_LAG

Ls = Gs*Rs;
Try = feedback(Ls,1);

%% Bodediagramme
figure;
bode(Gs,Rs,Ls,Try);
grid on;
legend("Gs","Rs","Ls","Try");
%% Step response
figure;
step(Try);
stepinfo(Try)
%% Ramp response
sympref('HeavisideAtOrigin', 1);
T_sim = 2;   % Simulationsdauer
t=0:0.001:T_sim;
[y,t]=lsim(Try,heaviside(t).*t,t);
figure;
plot(t,t);
hold on;
plot(t,y);
title('Rampenantwort Fhrungsbertragungsfunktion')
grid on;

%Abweichung nach 5s zur Rampe
T_sim = 10;   % Simulationsdauer
t=0:0.001:T_sim;
[y,t]=lsim(Try,heaviside(t).*t,t);

disp("Abweichung nach langer Zeit von Rampenfunktion");
abs(t(length(t))-y(length(t)))
